SystemOrganization addCategory: #ConfigurationOfBabyPhexample!

Object subclass: #ConfigurationOfBabyPhexample
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfBabyPhexample'!

!ConfigurationOfBabyPhexample class methodsFor: 'development support' stamp: 'SeanDeNigris 6/13/2014 12:47'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfBabyPhexample class methodsFor: 'private' stamp: 'SeanDeNigris 6/13/2014 12:47'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfBabyPhexample class methodsFor: 'private' stamp: 'SeanDeNigris 6/13/2014 12:47'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfBabyPhexample class methodsFor: 'private' stamp: 'SeanDeNigris 6/13/2014 12:47'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfBabyPhexample class methodsFor: 'metacello tool support' stamp: 'SeanDeNigris 6/13/2014 12:47'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfBabyPhexample class methodsFor: 'loading' stamp: 'SeanDeNigris 6/13/2014 12:47'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfBabyPhexample class methodsFor: 'loading' stamp: 'SeanDeNigris 6/13/2014 12:47'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfBabyPhexample class methodsFor: 'loading' stamp: 'SeanDeNigris 6/13/2014 12:47'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfBabyPhexample class methodsFor: 'accessing' stamp: 'SeanDeNigris 6/13/2014 12:47'!
project

	^self new project! !

!ConfigurationOfBabyPhexample class methodsFor: 'development support' stamp: 'SeanDeNigris 6/13/2014 12:47'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfBabyPhexample methodsFor: 'baselines' stamp: 'SeanDeNigris 6/13/2014 12:49'!
baseline01: spec
	<version: '0.1-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		spec repository: 'http://smalltalkhub.com/mc/SeanDeNigris/SeansPlayground/main/'.
		spec 
			project: 'BabyMock' with: [
				spec
					className: #ConfigurationOfBabyMock;
					versionString: #'stable';
					repository: 'http://smalltalkhub.com/mc/zeroflag/BabyMock/main/' ];
			project: 'Phexample' with: [
				spec
					className: #ConfigurationOfPhexample;
					versionString: #'stable';
					repository: 'http://smalltalkhub.com/mc/Phexample/Phexample/main/' ].
		spec package: #BabyPhexample with: [
				spec requires: #('BabyMock' 'Phexample' ). ]. ].
! !

!ConfigurationOfBabyPhexample methodsFor: 'accessing' stamp: 'SeanDeNigris 6/13/2014 12:47'!
customProjectAttributes
	 "Edit to return a collection of any custom attributes e.g. for conditional loading: Array with: #'Condition1' with: #'Condition2.
	For more information see: http://code.google.com/p/metacello/wiki/CustomProjectAttrributes"

	^ #().! !

!ConfigurationOfBabyPhexample methodsFor: 'symbolic versions' stamp: 'SeanDeNigris 6/13/2014 12:49'!
development: spec
	<symbolicVersion: #'development'>

	spec for: #'common' version: '0.1-baseline'.
! !

!ConfigurationOfBabyPhexample methodsFor: 'accessing' stamp: 'SeanDeNigris 6/13/2014 12:47'!
project

	^ project ifNil: [ 
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		project := MetacelloMCProject new projectAttributes: self customProjectAttributes. 
		(Smalltalk at: #MetacelloVersionConstructor) on: self project: project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfBabyPhexample methodsFor: 'symbolic versions' stamp: 'SeanDeNigris 10/19/2014 16:35'!
stable: spec
	<symbolicVersion: #'stable'>

	spec for: #'common' version: '1.0.1'.
! !

!ConfigurationOfBabyPhexample methodsFor: 'versions' stamp: 'SeanDeNigris 10/19/2014 07:52'!
version101: spec
	<version: '1.0.1' imports: #('0.1-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'stable'.
		spec description: 'version 1.0.1; upgrade to Phexample 2.0 with important bug fix'.
		spec author: 'SeanDeNigris'.
		spec timestamp: '10/13/2014 12:49'.
		spec 
			project: 'BabyMock' with: '1.2';
			project: 'Phexample' with: '2.0'.
		spec package: #BabyPhexample with: 'BabyPhexample-SeanDeNigris.1'. ].
! !

!ConfigurationOfBabyPhexample methodsFor: 'versions' stamp: 'SeanDeNigris 6/13/2014 12:49'!
version10: spec
	<version: '1.0' imports: #('0.1-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'stable'.
		spec description: 'version 1.0'.
		spec author: 'SeanDeNigris'.
		spec timestamp: '6/13/2014 12:49'.
		spec 
			project: 'BabyMock' with: '1.2';
			project: 'Phexample' with: '1.2'.
		spec package: #BabyPhexample with: 'BabyPhexample-SeanDeNigris.1'. ].
! !
